/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// AZTECS COUNTRY:
// CREATED BY DANY:
// JANUARY 2007:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/   
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
   }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
      float handedness = rmRandFloat(0.0, 1.0);
	  // > 0.5 is ocean to SE
	  // < 0.5 is ocean to NE
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.06);   
/*================================================================================================================*/   
// ********************************************* PICKS THE MAP SIZE: ******************************************** //
/*================================================================================================================*/
	  int playerTiles = 25000;
	  
	  if (cNumberNonGaiaPlayers >4)
		   playerTiles = 23000;
	  if (cNumberNonGaiaPlayers >6)
		   playerTiles = 21000;			

      int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
      // PICKS A DEFAULT WATER HEIGHT:
      rmSetSeaLevel(3);

      // SET THE SEA TYPE:
      rmSetSeaType("atlantic coast");
      
	  // ENABLE LOCAL WATER:
	  rmEnableLocalWater(false);
      
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("water");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("carolina");
	  rmSetMapType("water");
	  rmSetMapType("grass");
      
	  // SET THE LIGHTING:
	  rmSetLightingSet("carolina");
	  
	  // SET THE WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
	  int classPlayer=rmDefineClass("player");
      rmDefineClass("classCliff");
      int classbigContinent=rmDefineClass("big continent");
      rmDefineClass("corner");
      rmDefineClass("startingUnit");
      rmDefineClass("classForest");
      rmDefineClass("importantItem");
	  rmDefineClass("secrets");
	  rmDefineClass("flag");
	  rmDefineClass("classInvis");
	  rmDefineClass("canyon");
	  rmDefineClass("natives");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
      int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, rmXFractionToMeters(0.15));
	  //	rmEchoInfo("long player constraint = "+rmXFractionToMeters(0.15));

      // PLAYERS CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
   
	  int TCvsTC=rmCreateTypeDistanceConstraint("TC avoid same", "TownCenter", 50.0);
      int CWvsCW=rmCreateTypeDistanceConstraint("CW avoid same", "CoveredWagon", 50.0);
	  int forestvsTC=rmCreateTypeDistanceConstraint("forest vs. TC", "TownCenter", 20.0);
	  int forestvsCW=rmCreateTypeDistanceConstraint("forest vs. CW", "CoveredWagon", 20.0);
	  int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 20.0);
	  int shortAvoidTC=rmCreateTypeDistanceConstraint("stuff less vs TC", "TownCenter", 20.0);
	  int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);

      int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
      int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
      
	  // INVIS AVOIDANCE:
	  int invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent", rmClassID("classInvis"), rmXFractionToMeters(0.175));
	  if (cNumberNonGaiaPlayers >6)
	  invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent large map", rmClassID("classInvis"), rmXFractionToMeters(0.20));

      // BONUS AREA CONSTRAINT:
      int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);
	  
	  // CANYON AVOIDANCE:
      int avoidCanyon=rmCreateClassDistanceConstraint("avoid canyon", rmClassID("Canyon"), 12.0);

      // UNITS AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 8.0);
	  
	  // TREES AVOIDANCE:
	  int avoidTree=rmCreateTypeDistanceConstraint("stuff avoids tree", "TreeCarolinaGrass", 4.0);
	  int treeAvoidTree=rmCreateTypeDistanceConstraint("tree avoids tree", "TreeCarolinaGrass", 8.0);
	  
	  // GOLD AVOIDANCE:
	  int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 4.0);
	  int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 8.0);
	  
	  // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
      int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 10.0);
      int avoidBerries=rmCreateTypeDistanceConstraint("berry vs berry", "berryBush", 10.0);
	  int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 10.0);
	  int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 10.0);
      
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateTypeDistanceConstraint("stuffs avoids nugget", "abstractNugget", 6.0);
	  int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoids nugget", "abstractNugget", 12.0);

      // IMPASSABLE LAND AVOIDANCE:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
      int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 12.0);
	  if (cNumberNonGaiaPlayers < 3)
	  longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land small map", "Land", false, 12.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 45.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	  int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

      // UNIT AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);

      // IMPORTANT OBJECT AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	  int nativeAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 20.0);
      int avoidImportantItem=rmCreateClassDistanceConstraint("sockets avoid each other", rmClassID("importantItem"), 12.0);
      int silverAvoidImportantItem=rmCreateClassDistanceConstraint("silver avoids sockets", rmClassID("importantItem"), 12.0);

      // CONSTRAINT TO AVOID WATER:
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 16.0);
	  int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
	 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/	  
// ************************************ IF ONLY 2 PLAYERS PLACE AS 2 POINTS: ************************************ //
/*================================================================================================================*/
		if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.0, 0.15);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.55, 0.70);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// **************************************** SET UP THE PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(1000);
/*----------------------------------------------------------------------------------------------------------------*/	  
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
      // CREATE THE AREA:
	  int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
	  rmSetPlayerArea(i, id);
	  
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
      
	  // SET THE SIZE:
	  rmSetAreaSize(id, playerFraction, playerFraction);
	  
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint);
	  rmAddAreaConstraint(id, avoidWater8);
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA COHERENCE:
	  rmSetAreaCoherence(id, 0.9);
   }
/*----------------------------------------------------------------------------------------------------------------*/   
      // BUILD THE AREAS:
	  rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ******************** INVISIBLE CONTINENT ADDED TO HAVE BIG CONTINENT AVOID PLAYER AREAS: ********************* //
/*================================================================================================================*/
      int invisContinentID=rmCreateArea("invisible continent for constraint");
	  rmSetAreaSize(invisContinentID, 0.01, 0.01);
      rmSetAreaWarnFailure(invisContinentID, false);

	  if(handedness < 0.5) // NE ocean
	  {
	  rmSetAreaLocation(invisContinentID, 0.99, 0.5);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.95, 0.30, 0.99, 0.5);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.99, 0.5, 0.95, 0.70);
	  }
	  else
	  {			
	  rmSetAreaLocation(invisContinentID, 0.99, 0.5);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.95, 0.30, 0.99, 0.5);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.99, 0.5, 0.95, 0.70);
	  }
	  
	  rmAddAreaToClass(invisContinentID, rmClassID("classInvis"));
	  rmSetAreaCoherence(invisContinentID, 0.8);
      //rmSetAreaBaseHeight(invisContinentID, 3);
      //rmSetAreaMix(invisContinentID, "carolina_grass");

      // BUILD THE AREAS:
      rmBuildArea(invisContinentID);
/*================================================================================================================*/   
/*================================================================================================================*/	  
// ***************************************** BUILD THE BIG CONTINENT: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int bigContinentID = -1;
	  bigContinentID=rmCreateArea("big continent");
	  rmSetAreaSize(bigContinentID, 0.40, 0.47); // 0.38 0.47
	  rmSetAreaWarnFailure(bigContinentID, false);
      rmAddAreaConstraint(bigContinentID, invisConstraint);
      rmAddAreaToClass(bigContinentID, classbigContinent);

    /*  rmSetAreaMinBlobs(bigContinentID, 10);
      rmSetAreaMaxBlobs(bigContinentID, 10);
      rmSetAreaMinBlobDistance(bigContinentID, rmXFractionToMeters(0.1));
      rmSetAreaMaxBlobDistance(bigContinentID, rmXFractionToMeters(0.4));*/

      rmSetAreaSmoothDistance(bigContinentID, 50);
	  rmSetAreaMix(bigContinentID, "carolina_grass");
      rmSetAreaElevationType(bigContinentID, cElevTurbulence);
      rmSetAreaElevationVariation(bigContinentID, 4.0);
      rmSetAreaBaseHeight(bigContinentID, 3.5);
      rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
      rmSetAreaElevationOctaves(bigContinentID, 3);
      rmSetAreaElevationPersistence(bigContinentID, 0.2);
	  rmSetAreaElevationNoiseBias(bigContinentID, 1);
		
      rmSetAreaCoherence(bigContinentID, 0.15);
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** CHOOSE RIGHT OR LEFT-HANDED CONTINENT: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      if(handedness < 0.5) // NE ocean
	  {
      rmSetAreaLocation(bigContinentID, 0.25, 0.5);
	  rmAddAreaInfluenceSegment(bigContinentID, 0.5, 0.0, 0.5, 1.0); 
	  rmAddAreaInfluenceSegment(bigContinentID, 0.0, 0.5, 0.4, 0.5);
	  	  
	  }
      else // NE ocean
	  {
       rmSetAreaLocation(bigContinentID, 0.25, 0.5);
	   rmAddAreaInfluenceSegment(bigContinentID, 0.5, 0.0, 0.5, 1.0); 
	   rmAddAreaInfluenceSegment(bigContinentID, 0.0, 0.5, 0.4, 0.5);
       }
/*----------------------------------------------------------------------------------------------------------------*/	  
	  rmSetAreaEdgeFilling(bigContinentID, 10);
		
      rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);

	  rmBuildArea(bigContinentID);
/*================================================================================================================*/
// ********************************************* MOUNTAIN IN CENTER ********************************************* //
/*================================================================================================================*/
	    int numTries = 1;
	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa 1"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Bayou");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.40, 0.50); 
		rmAddAreaInfluencePoint(smallMesaID, 0.25, 0.55); // ADDED BY ME:
		rmAddAreaInfluencePoint(smallMesaID, 0.30, 0.50); // ADDED BY ME:
		rmAddAreaInfluencePoint(smallMesaID, 0.30, 0.45); // ADDED BY ME:
	    rmAddAreaInfluencePoint(smallMesaID, 0.45, 0.50); // ADDED BY ME:
		//rmAddAreaInfluenceSegment(smallMesaID, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.46, 0.40, 0.53, 0.38); //Right
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.48, 0.43); //Left
		rmBuildArea(smallMesaID);
	}

	    // SPECIAL AREA CONSTRAINT AND USE IT TO MAKE RESOURCES AVOID THE BIG MTN IN THE CENTER:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);

        for(i=0; <numTries)
	{
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "Bayou");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmSetAreaLocation(smallMesa2ID, 0.45, 0.70); 
		rmBuildArea(smallMesa2ID);
	}		
	
	    for(i=0; <numTries)
	{
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Bayou");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa3ID, 0.88);
		rmSetAreaLocation(smallMesa3ID, 0.15, 0.30); 
		rmBuildArea(smallMesa3ID);
	}	

        for(i=0; <numTries)
	{
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4"+i);
		rmSetAreaSize(smallMesa4ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, "Bayou");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa4ID, 0.88);
		rmSetAreaLocation(smallMesa4ID, 0.125, 0.65); 
		rmBuildArea(smallMesa4ID);
	}		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE TRADE ROUTES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// *********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************ //
/*================================================================================================================*/
	  // PLACE TC OR CW NOW: FIND LOCATION LATER TO PLACE OTHER RESOURCES:

	  // DEFINE THE TCID:
	  int TCID = rmCreateObjectDef("player TC");
	  if ( rmGetNomadStart())
		  rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	  else
		  rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	  rmSetObjectDefMinDistance(TCID, 0.0);
	  rmSetObjectDefMaxDistance(TCID, 20.0);
	  rmAddObjectDefConstraint(TCID, avoidTradeRoute);
      rmAddObjectDefConstraint(TCID, TCvsTC);
      rmAddObjectDefConstraint(TCID, CWvsCW);
      rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	  for(i=1; <cNumberPlayers)
	{
	  rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

	  // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
      rmSetObjectDefMinDistance(startingUnits, 6.0);
      rmSetObjectDefMaxDistance(startingUnits, 10.0);
	  rmAddObjectDefConstraint(startingUnits, avoidAll);
      rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE THE PLAYER SILVER MINES:
	  int playerSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilverID, 18.0);
	  rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	  rmAddObjectDefConstraint(playerSilverID, avoidAll);
      rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);

	  // DEFINE THE PLAYER CRATES:
	  int playerCrateID=rmCreateObjectDef("bonus starting crates");
      rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2,3), 4.0);
      rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1,3), 4.0);
      rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
      rmSetObjectDefMinDistance(playerCrateID, 6);
      rmSetObjectDefMaxDistance(playerCrateID, 10);
	  rmAddObjectDefConstraint(playerCrateID, avoidAll);
      rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);

	  // DEFINE THE PLAYER BERRIES:
	  int playerBerryID=rmCreateObjectDef("player berries");
      rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
      rmSetObjectDefMinDistance(playerBerryID, 10);
      rmSetObjectDefMaxDistance(playerBerryID, 15);
	  rmAddObjectDefConstraint(playerBerryID, avoidAll);
	  //rmAddObjectDefConstraint(playerBerryID, avoidNatives);
	  rmAddObjectDefConstraint(playerBerryID, smallMesaConstraint);
      rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);

	  // DEFINE THE FAR BERRIES:
	  int farBerriesID=rmCreateObjectDef("far berries");
      rmAddObjectDefItem(farBerriesID, "berryBush", rmRandInt(5,8), 4.0);
      rmSetObjectDefMinDistance(farBerriesID, 30);
      rmSetObjectDefMaxDistance(farBerriesID, 40);
	  rmAddObjectDefConstraint(farBerriesID, avoidAll);
	  rmAddObjectDefConstraint(farBerriesID, smallMesaConstraint);
	  rmAddObjectDefConstraint(farBerriesID, avoidNatives);
	  rmAddObjectDefConstraint(farBerriesID, avoidTC);
	  rmAddObjectDefConstraint(farBerriesID, avoidCW);
	  rmAddObjectDefConstraint(farBerriesID, avoidBerries);
      rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);

	  // DEFINE THE PLAYER TREE:
	  int playerTreeID=rmCreateObjectDef("player trees");
      rmAddObjectDefItem(playerTreeID, "TreeCarolinaGrass", 1, 0.0);
      rmSetObjectDefMinDistance(playerTreeID, 8);
      rmSetObjectDefMaxDistance(playerTreeID, 12);
	  rmAddObjectDefConstraint(playerTreeID, avoidAll);
      rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);
	  
	  // DEFINE THE FAR PLAYER TREE:
	  int farPlayerTreeID=rmCreateObjectDef("far player trees");
      rmAddObjectDefItem(farPlayerTreeID, "TreeCarolinaGrass", 1, 0.0);
      rmSetObjectDefMinDistance(farPlayerTreeID, 20);
      rmSetObjectDefMaxDistance(farPlayerTreeID, 35);
	  rmAddObjectDefConstraint(farPlayerTreeID, avoidAll);
      rmAddObjectDefConstraint(farPlayerTreeID, shortAvoidImpassableLand);

	  // DEFINE THE WATER FLAG:
	  int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	  rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
      rmAddClosestPointConstraint(flagEdgeConstraint);
	  rmAddClosestPointConstraint(flagVsFlag);
	  rmAddClosestPointConstraint(bigContinentConstraint);
	  rmAddClosestPointConstraint(fishLand);
	 
      // DEFINE THE NUGGETS EASY PER PLAYER:
	  int nugget1= rmCreateObjectDef("nugget easy"); 
	  rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget1, avoidNugget);
  	  rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget1, avoidAll);
	  rmAddObjectDefConstraint(nugget1, avoidCanyon);
	  rmAddObjectDefConstraint(nugget1, avoidNatives);
	  rmSetObjectDefMinDistance(nugget1, 40.0);
	  rmSetObjectDefMaxDistance(nugget1, 50.0);

	  // DEFINE THE NUGGETS MEDIUM PER PLAYER:
	  int nugget2= rmCreateObjectDef("nugget medium"); 
	  rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget2, 0.0);
	  rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget2, avoidNugget);
  	  rmAddObjectDefConstraint(nugget2, avoidTC);
  	  rmAddObjectDefConstraint(nugget2, avoidCW);
  	  rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget2, avoidAll);
	  rmAddObjectDefConstraint(nugget2, avoidCanyon);
	  rmAddObjectDefConstraint(nugget2, avoidNatives);
  	  rmAddObjectDefConstraint(nugget2, avoidWater20);
	  rmSetObjectDefMinDistance(nugget2, 55.0);
	  rmSetObjectDefMaxDistance(nugget2, 60.0);
      
	  // DEFINE THE NEAR DEERS:
	  int nearDeerID=rmCreateObjectDef("deer herds near town");
      rmAddObjectDefItem(nearDeerID, "deer", rmRandInt(8,10), 10.0);
      rmSetObjectDefMinDistance(nearDeerID, 30);
      rmSetObjectDefMaxDistance(nearDeerID, 40);
      rmAddObjectDefConstraint(nearDeerID, avoidDeer);
	  rmAddObjectDefConstraint(nearDeerID, avoidAll);
	  rmAddObjectDefConstraint(nearDeerID, avoidNatives);
	  rmAddObjectDefConstraint(nearDeerID, avoidCanyon);
	  rmAddObjectDefConstraint(nearDeerID, avoidWater8);
      rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(nearDeerID, true);

	  // DEFINE THE FAR DEERS:
	  int farDeerID=rmCreateObjectDef("deer herds far away");
	  
	  int bonusChance=rmRandFloat(0, 1);
      if(bonusChance<0.5)   
      rmAddObjectDefItem(farDeerID, "deer", rmRandInt(8,10), 10.0);
      else
      rmAddObjectDefItem(farDeerID, "deer", rmRandInt(12,16), 10.0);
      
	  rmSetObjectDefMinDistance(farDeerID, 60);
      rmSetObjectDefMaxDistance(farDeerID, 70);
      rmAddObjectDefConstraint(farDeerID, avoidDeer);
	  rmAddObjectDefConstraint(farDeerID, avoidAll);
	  rmAddObjectDefConstraint(farDeerID, avoidNatives);
	  rmAddObjectDefConstraint(farDeerID, avoidCanyon);
	  rmAddObjectDefConstraint(farDeerID, avoidWater8);
	  rmAddObjectDefConstraint(farDeerID, avoidTC);
	  rmAddObjectDefConstraint(farDeerID, avoidCW);
      rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(farDeerID, true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.25, 0.70);
	}
	
	  if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.125, 0.45);
	}
	
	  if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.55, 0.60);
	}
	
	  if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.50, 0.35);
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FAR SILVER MINES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int silverID = -1;
	  int silverCount = (cNumberNonGaiaPlayers*2 + rmRandInt(1,2));
	  rmEchoInfo("silver count = "+silverCount);

	  for(i=0; < silverCount)
	{
      silverID = rmCreateObjectDef("silver "+i);
	  rmAddObjectDefItem(silverID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverID, 0.0);
      rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(silverID, avoidFastCoin);
      rmAddObjectDefConstraint(silverID, avoidAll);
	  rmAddObjectDefConstraint(silverID, avoidTree);
	  rmAddObjectDefConstraint(silverID, avoidGold);
	  rmAddObjectDefConstraint(silverID, avoidNatives);
	  rmAddObjectDefConstraint(silverID, smallMesaConstraint);
      rmAddObjectDefConstraint(silverID, avoidTC);
	  rmAddObjectDefConstraint(silverID, avoidCW);
	  rmAddObjectDefConstraint(silverID, silverAvoidImportantItem);
      rmAddObjectDefConstraint(silverID, longAvoidImpassableLand);
      rmAddObjectDefConstraint(silverID, avoidTradeRoute);
	  rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
      int fishID=rmCreateObjectDef("sardine");
      rmAddObjectDefItem(fishID, "FishSardine", 3, 4.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

      int fish2ID=rmCreateObjectDef("tarpon");
      rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 4.0);
      rmSetObjectDefMinDistance(fish2ID, 0.0);
      rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fish2ID, fishVsFishID);
      rmAddObjectDefConstraint(fish2ID, fishLand);
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

	  int whaleID=rmCreateObjectDef("whale");
      rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
      rmSetObjectDefMinDistance(whaleID, 0.0);
      rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
      rmAddObjectDefConstraint(whaleID, whaleLand);
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************* PLACE PLAYER STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	
	{
		
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		if (rmGetNomadStart() == false)
		
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
				
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(farBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	}

	    rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************ PLACE EXTRA NUGGETS NOT PER PLAYER: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // NUGGET HARD:
	  int nugget3= rmCreateObjectDef("nugget hard"); 
	  rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(3, 3);
	  rmSetObjectDefMinDistance(nugget3, 0.0);
	  rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget3, avoidNugget);
  	  rmAddObjectDefConstraint(nugget3, avoidTC);
  	  rmAddObjectDefConstraint(nugget3, avoidCW);
  	  rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget3, avoidAll);
	  rmAddObjectDefConstraint(nugget3, avoidGold);
	  rmAddObjectDefConstraint(nugget3, avoidNatives);
	  rmAddObjectDefConstraint(nugget3, smallMesaConstraint);
  	  rmAddObjectDefConstraint(nugget3, avoidWater20);
	  rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
	    // NUGGET NUTS:
		if (rmRandFloat(0,1) < 0.1)
	{
		int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget4, avoidNugget);
  		rmAddObjectDefConstraint(nugget4, avoidTC);
  		rmAddObjectDefConstraint(nugget4, avoidCW);
  		rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget4, avoidAll);
		rmAddObjectDefConstraint(nugget4, avoidGold);
		rmAddObjectDefConstraint(nugget4, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget4, avoidNatives);
  		rmAddObjectDefConstraint(nugget4, avoidWater20);
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(0,3));
	}
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE RESOURCES 1: **************************************** //
/*================================================================================================================*/
		int berries1ID= rmCreateObjectDef("The Berries 1"); 
		rmAddObjectDefItem(berries1ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.19, 0.46);	
		
		int tree1ID= rmCreateObjectDef("The Trees 1"); 
		rmAddObjectDefItem(tree1ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree1ID, 0.0);
		rmSetObjectDefMaxDistance(tree1ID, 0.0);
		rmAddObjectDefConstraint(tree1ID, avoidTree);
		rmAddObjectDefConstraint(tree1ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.11, 0.55);
		
		int gold1ID= rmCreateObjectDef("Gold Mines 1"); 
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmAddObjectDefConstraint(gold1ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.05, 0.495);
		
		int nugget5= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget5, 0.0);
	    rmSetObjectDefMaxDistance(nugget5, 0.0);
	    rmAddObjectDefConstraint(nugget5, avoidNugget);
  	    rmAddObjectDefConstraint(nugget5, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget5, 0, 0.09, 0.37);
		
		int tree2ID= rmCreateObjectDef("The Trees 2"); 
		rmAddObjectDefItem(tree2ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
		rmSetObjectDefMaxDistance(tree2ID, 0.0);
		rmAddObjectDefConstraint(tree2ID, avoidTree);
		rmAddObjectDefConstraint(tree2ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.19, 0.39);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 2: ***************************************** //
/*================================================================================================================*/        		
		int berries2ID= rmCreateObjectDef("The Berries 2"); 
		rmAddObjectDefItem(berries2ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.28, 0.75);
		
		int gold2ID= rmCreateObjectDef("Gold Mines 2"); 
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmAddObjectDefConstraint(gold2ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.20, 0.80);
		
		int tree3ID= rmCreateObjectDef("The Trees 3"); 
		rmAddObjectDefItem(tree3ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree3ID, 0.0);
		rmSetObjectDefMaxDistance(tree3ID, 0.0);
		rmAddObjectDefConstraint(tree3ID, avoidTree);
		rmAddObjectDefConstraint(tree3ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.15, 0.75);
		
		int tree4ID= rmCreateObjectDef("The Trees 4"); 
		rmAddObjectDefItem(tree4ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree4ID, 0.0);
		rmSetObjectDefMaxDistance(tree4ID, 0.0);
		rmAddObjectDefConstraint(tree4ID, avoidTree);
		rmAddObjectDefConstraint(tree4ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.35, 0.65);
		
		int nugget6= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget6, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget6, 0.0);
	    rmSetObjectDefMaxDistance(nugget6, 0.0);
	    rmAddObjectDefConstraint(nugget6, avoidNugget);
  	    rmAddObjectDefConstraint(nugget6, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget6, 0, 0.20, 0.64);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 3: ***************************************** //
/*================================================================================================================*/
        int berries3ID= rmCreateObjectDef("The Berries 3"); 
		rmAddObjectDefItem(berries3ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.55, 0.50);
		
		int tree5ID= rmCreateObjectDef("The Trees 5"); 
		rmAddObjectDefItem(tree5ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree5ID, 0.0);
		rmSetObjectDefMaxDistance(tree5ID, 0.0);
		rmAddObjectDefConstraint(tree5ID, avoidTree);
		rmAddObjectDefConstraint(tree5ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.55, 0.70);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.45, 0.60);
		
		int gold3ID= rmCreateObjectDef("Gold Mines 3"); 
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
		rmAddObjectDefConstraint(gold3ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.61, 0.525);
		
		int nugget7= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget7, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget7, 0.0);
	    rmSetObjectDefMaxDistance(nugget7, 0.0);
	    rmAddObjectDefConstraint(nugget7, avoidNugget);
  	    rmAddObjectDefConstraint(nugget7, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget7, 0, 0.60, 0.65);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 3: ***************************************** //
/*================================================================================================================*/
        int berries4ID= rmCreateObjectDef("The Berries 4"); 
		rmAddObjectDefItem(berries4ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
		rmAddObjectDefConstraint(berries4ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.55, 0.30);

        int nugget8= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget8, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget8, 0.0);
	    rmSetObjectDefMaxDistance(nugget8, 0.0);
	    rmAddObjectDefConstraint(nugget8, avoidNugget);
  	    rmAddObjectDefConstraint(nugget8, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget8, 0, 0.60, 0.40);
		
		int tree6ID= rmCreateObjectDef("The Trees 6"); 
		rmAddObjectDefItem(tree6ID, "TreeCarolinaGrass", rmRandInt(12,18), 8.0);
		rmSetObjectDefMinDistance(tree6ID, 0.0);
		rmSetObjectDefMaxDistance(tree6ID, 0.0);
		rmAddObjectDefConstraint(tree6ID, avoidTree);
		rmAddObjectDefConstraint(tree6ID, treeAvoidTree);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.4, 0.35);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.52, 0.42);
		
		int gold4ID= rmCreateObjectDef("Gold Mines 4"); 
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
		rmAddObjectDefConstraint(gold4ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.50, 0.25);
		
        		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
		int treeID= rmCreateObjectDef("The Trees"); 
		rmAddObjectDefItem(treeID, "TreeCarolinaGrass", 1, 0.0);
		rmSetObjectDefMinDistance(treeID, 0.0);
		rmSetObjectDefMaxDistance(treeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(treeID, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(treeID, avoidTree);
		rmAddObjectDefConstraint(treeID, treeAvoidTree);
  		rmAddObjectDefConstraint(treeID, avoidTC);
  		rmAddObjectDefConstraint(treeID, avoidCW);
  		rmAddObjectDefConstraint(treeID, avoidGold);
  		rmAddObjectDefConstraint(treeID, avoidAll);
		rmAddObjectDefConstraint(treeID, avoidBerries);
		rmAddObjectDefConstraint(treeID, avoidNugget);
		rmAddObjectDefConstraint(treeID, avoidCanyon);
		rmAddObjectDefConstraint(treeID, avoidNatives);
  		rmAddObjectDefConstraint(treeID, avoidWater20);
		rmPlaceObjectDefAtLoc(treeID, 0, 0.5, 0.5, 25);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         
		 int forestTreeID = 0;
         numTries=6*cNumberNonGaiaPlayers;
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
         rmSetAreaForestType(forest, "carolina pine forest");
         //rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.8);
         rmSetAreaForestClumpiness(forest, 0.6);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 16.0);
         rmSetAreaMaxBlobDistance(forest, 70.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 0);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidBerries);
		 rmAddAreaConstraint(forest, avoidGold);
		 rmAddAreaConstraint(forest, avoidTree);
		 rmAddAreaConstraint(forest, avoidNugget);
		 rmAddAreaConstraint(forest, avoidNatives);
		 rmAddAreaConstraint(forest, avoidCanyon);
         rmAddAreaConstraint(forest, forestvsTC);
         rmAddAreaConstraint(forest, forestvsCW); 
         rmAddAreaConstraint(forest, longAvoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute);

         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/
   	  